<?php

namespace Teknisa\FIN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\FIN\Controllers\TeknisaCrud;

class TpcredbancClassfinancContctbl extends TeknisaCrud{

    protected $dataSourceName = 'tpcredbanc_classfinanc_contctbl';

    public function save(DTO\Request $request, DTO\Response $response) {
    	$dataSet = $request->getDataSet();
    	$rows = $dataSet->getRows();
    	$row = $rows[0];
    	if (!$row["__is_new"]) {
			$this->setBeforeSave($row);
			parent::save($request, $response);
		} else {
			$condition = array(
				array(
			   		"value" => $row["CDTPCREDBANC"],
			   		"operator" => "=",
			   		"columnName" => "CDTPCREDBANC"
			   	)
			);
			$filterCriteria = new FilterCriteria($this->dataSourceName, $condition);
			$newFilterCriteria = $this->populateParameterBag($filterCriteria);
			$dataSetFilter = $this->dataSourceManager->findBy($newFilterCriteria);
			$rowsFilter = $dataSetFilter->getRows();
			if(empty($rowsFilter)){
				$this->setBeforeSave($row);
				parent::save($request, $response);
			} else {
					$response->setError(new DTO\Response\Error("Código já existente", 1));
				}
		}	
	}
	public function setBeforeSave ($row){
		if ($row["IDCTBLCRBANC"]=='Y') {
			$row["IDCTBLCRBANC"]='S';
		}
	}		
}