<?php

namespace Teknisa\FIN\Modules\ContaReceber\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\FIN\Controllers\TeknisaCrud;
use Teknisa\Libs\Service\CRUD as CrudService;
use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\FIN\Modules\ContaReceber\Services\Rec18000CompensacaoTitulosReceberService;

class Rec18000CompensacaoTitulosReceberController extends TeknisaCrud{

    protected $dataSourceName;
    protected $parameterBagColumns = array(
        "CDEMPRESA", "TCDOPERADOR", "CDOPERADOR", "TCDFORNECED", "CDFORNECED", "NRORG",
        "CONTAFILTRO", "TCDREDUCONT", "DATAINI", "DATAFIN", "TVALOR", "VALORINI", "CDREDUCONT",
        "VALORFIN", "TTIPO", "CDTPCREDBANC", "TDATA", "STATUS", "NRDUPLICATA", "IDPROTESTREC", "NRLANCCOMPREC",
        "CDNOSNUMPAG", "FILILANC", "FILIORIG", "DOCINICIAL", "DOCFINAL", "TCDCLIENTE", "CDCLIENTE",
        "CDTPBAIXAPAG", "DATAINICIAL", "DATAFINAL", "VALORINICIAL", "VALORFINAL", "TVALOR", "IDHABIBOLE", "TIPOBX"
        );
    protected $environment;
    protected $entityManager;
    protected $services;

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()));
        $this->dataSourceName = $dataSource;
        parent::find($request, $response);
    }

    public function __construct($crudService, ParameterBag $parameterBag, Environment $environment,
                                Rec18000CompensacaoTitulosReceberService $services, EntityManager $entityManager){
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->services = $services;
        $this->entityManager = $entityManager;
    }

    public function saveCompensacaoCobranca(DTO\Request $request, DTO\Response $response){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try{
            $rows = $request->getDataSet()->getRows();
            $nrorg = $this->environment->getNrOrgTrab();
            $operador = $this->environment->getCdOperador();
            $rowReceber = $rows[0];
            unset($rows[0]);
            $rowsPagar = $rows;
            $this->services->geraCompensacao($rowReceber, $rowsPagar);
            $this->entityManager->flush();
            $connection->commit();
        }catch(\Exception $e){
            $connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }

    public function deleteCompensacaoCobranca(DTO\Request $request, DTO\Response $response){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try{
            $rows = $request->getDataSet()->getRows();
            $compensacaoReceber = $rows[0];
            unset($rows[0]);
            $contaPagar = $rows;
            $this->services->deleteCompensacaoCobranca($compensacaoReceber, $contaPagar);
            $this->entityManager->flush();
            $connection->commit();
        }catch(\Exception $e){
            $connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}